#include "irkimpl.h"
#include <qpixmap.h>
#include <stdio.h>
#include "lirc_client.h"
#include <stdlib.h>
#include <unistd.h>
#include "irk_build.h"
#include "Infrared.xpm"
#include "pocketop.xpm"
#include "targus.xpm"
#include "palm.xpm"
// #include "ps2.xpm"

QPixmap *IRKImpl::icn=NULL;
QPixmap *IRKImpl::icn_pocketop=NULL;
QPixmap *IRKImpl::icn_targus=NULL;
QPixmap *IRKImpl::icn_palm=NULL;
QPixmap *IRKImpl::icn_TKB780U=NULL;
QPixmap *IRKImpl::icn_F8U1500=NULL;
QPixmap *IRKImpl::icn_F8U1500T=NULL;
QPixmap *IRKImpl::icn_PalmOne3169WW=NULL;
QPixmap *IRKImpl::icn_HPfoldableBT=NULL;
QPixmap *IRKImpl::icn_patapata=NULL;
QPixmap *IRKImpl::icn_US102=NULL;
QPixmap *IRKImpl::icn_JP106=NULL;

IRKImpl::IRKImpl()
    : input(0),ref(0)
{
	if ( !icn )
		icn = new QPixmap((const char **)Infrared_xpm);
	if(!icn_pocketop)
		icn_pocketop = new QPixmap((const char **)pocketop_xpm);
	if(!icn_targus)
		icn_targus = new QPixmap((const char **)targus_xpm);
	if(!icn_palm)
		icn_palm = new QPixmap((const char **)palm_xpm);
	if(!icn_TKB780U)
		icn_TKB780U = new QPixmap((const char **)palm_xpm);
	if(!icn_F8U1500)
		icn_F8U1500 = new QPixmap((const char **)palm_xpm);
	if(!icn_F8U1500T)
		icn_F8U1500T = new QPixmap((const char **)palm_xpm);
	if(!icn_PalmOne3169WW)
		icn_PalmOne3169WW = new QPixmap((const char **)palm_xpm);
	if(!icn_HPfoldableBT)
		icn_HPfoldableBT = new QPixmap((const char **)palm_xpm);
	if(!icn_patapata)
		icn_patapata = new QPixmap((const char **)targus_xpm);
	if(!icn_US102)
//		icn_US102 = new QPixmap((const char **)ps2_xpm);
		icn_US102 = new QPixmap((const char **)palm_xpm);
	if(!icn_JP106)
//		icn_JP106 = new QPixmap((const char **)ps2_xpm);
		icn_JP106 = new QPixmap((const char **)palm_xpm);
}

IRKImpl::~IRKImpl()
{
    delete input;
}

QRESULT IRKImpl::queryInterface( const QUuid &uuid, QUnknownInterface **iface )
{
    *iface = 0;
    if ( uuid == IID_QUnknown )
        *iface = this;
    else if ( uuid == IID_InputMethod )
        *iface = this;

    if ( *iface )
        (*iface)->addRef();
    return QS_OK;
}

void IRKImpl::resetState()
{
}


QWidget *IRKImpl::inputMethod( QWidget *parent, Qt::WFlags f )
{
    if ( !input )
        input = new CGIRK( parent, "cgIRK", f );
    return input;
}


QString IRKImpl::name()
{
#if POCKETOP_BUILD
	if((input)&&(input->currentKeyboard()->mode()==IRKMODE_POCKETOP))
		return QString("Pocketop");
	else
#endif
	if((input)&&(input->currentKeyboard()->mode()==IRKMODE_TARGUS)) {
		return QString("Targus");
	} else if((input)&&(input->currentKeyboard()->mode()==IRKMODE_PALM)) {
		return QString("Palm");
	} else if((input)&&(input->currentKeyboard()->mode()==IRKMODE_TKB780U)) {
		return QString("TKB780U");
	} else if((input)&&(input->currentKeyboard()->mode()==IRKMODE_F8U1500)) {
		return QString("F8U1500");
	} else if((input)&&(input->currentKeyboard()->mode()==IRKMODE_F8U1500T)) {
		return QString("F8U1500T");
	} else if((input)&&(input->currentKeyboard()->mode()==IRKMODE_PalmOne3169WW)) {
		return QString("PalmOne3169WW");
	} else if((input)&&(input->currentKeyboard()->mode()==IRKMODE_HPfoldableBT)) {
		return QString("HPfoldableBT");
	} else if((input)&&(input->currentKeyboard()->mode()==IRKMODE_PATAPATA)) {
		return QString("Patapata");
	} else if((input)&&(input->currentKeyboard()->mode()==IRKMODE_US102)) {
		return QString("US102");
	} else if((input)&&(input->currentKeyboard()->mode()==IRKMODE_JP106)) {
		return QString("JP106");
	} else {
		return QString("IRK");
	}
}


QPixmap *IRKImpl::icon()
{
	if((input)&&(input->currentKeyboard()->mode()==IRKMODE_POCKETOP))
		return icn_pocketop;
	else if((input)&&(input->currentKeyboard()->mode()==IRKMODE_TARGUS))
		return icn_targus;
	else if((input)&&(input->currentKeyboard()->mode()==IRKMODE_PALM))
		return icn_palm;
	else if((input)&&(input->currentKeyboard()->mode()==IRKMODE_TKB780U))
		return icn_TKB780U;
	else if((input)&&(input->currentKeyboard()->mode()==IRKMODE_F8U1500))
		return icn_F8U1500;
	else if((input)&&(input->currentKeyboard()->mode()==IRKMODE_F8U1500T))
		return icn_F8U1500T;
	else if((input)&&(input->currentKeyboard()->mode()==IRKMODE_PalmOne3169WW))
		return icn_PalmOne3169WW;
	else if((input)&&(input->currentKeyboard()->mode()==IRKMODE_HPfoldableBT))
		return icn_HPfoldableBT;
	else if((input)&&(input->currentKeyboard()->mode()==IRKMODE_PATAPATA))
		return icn_patapata;
	else if((input)&&(input->currentKeyboard()->mode()==IRKMODE_US102))
		return icn_US102;
	else if((input)&&(input->currentKeyboard()->mode()==IRKMODE_JP106))
		return icn_JP106;
	else
		return icn;
}


/*
 The onKeyPress() function must connect the supplied slot to the signal that is emitted when
 a key press is generated. 
 The following code will connect the signal to the supplied slot: 
*/

void IRKImpl::onKeyPress( QObject *receiver, const char *slot )
{
    if ( input )
        QObject::connect( input, SIGNAL(key(ushort,ushort,ushort,bool,bool)), receiver, slot );
}


Q_EXPORT_INTERFACE()
{
    Q_CREATE_INSTANCE( IRKImpl )
}

